// AddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "AddDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDlg dialog


CAddDlg::CAddDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddDlg)
	m_szObj1 = _T("");
	m_szObj2 = _T("");
	m_szObj3 = _T("");
	m_szObj4 = _T("");
	m_szObjGroup = _T("");
	m_dateYMD = 0;
	m_dateHMS = 0;
	m_szContent = _T("");
	m_serial = 0;
	m_msec = 0;
	m_dev = _T("");
	//}}AFX_DATA_INIT

	m_dateYMD = CTime::GetCurrentTime();
	m_pDlg = (CToolView *)pParent;
}


void CAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDlg)
	DDX_Control(pDX, IDC_DEVTYPE, m_devType);
	DDX_Control(pDX, IDC_APPSYS, m_appSys);
	DDX_Control(pDX, IDC_AOJ, m_aoj);
	DDX_Control(pDX, IDC_PRIO, m_prio);
	DDX_Control(pDX, IDC_COMBOTYPE, m_almType);
	DDX_Text(pDX, IDC_OBJ1, m_szObj1);
	DDV_MaxChars(pDX, m_szObj1, 12);
	DDX_Text(pDX, IDC_OBJ2, m_szObj2);
	DDV_MaxChars(pDX, m_szObj2, 12);
	DDX_Text(pDX, IDC_OBJ3, m_szObj3);
	DDV_MaxChars(pDX, m_szObj3, 12);
	DDX_Text(pDX, IDC_OBJ4, m_szObj4);
	DDV_MaxChars(pDX, m_szObj4, 12);
	DDX_Text(pDX, IDC_OBJGROUP, m_szObjGroup);
	DDV_MaxChars(pDX, m_szObjGroup, 8);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER_ADD1, m_dateYMD);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER_ADD2, m_dateHMS);
	DDX_Text(pDX, IDC_CONTENT, m_szContent);
	DDV_MaxChars(pDX, m_szContent, 128);
	DDX_Text(pDX, IDC_SERIAL, m_serial);
	DDX_Text(pDX, IDC_MSEC, m_msec);
	DDV_MinMaxInt(pDX, m_msec, 0, 999);
	DDX_Text(pDX, IDC_DEV, m_dev);
	DDV_MaxChars(pDX, m_dev, 32);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddDlg, CDialog)
	//{{AFX_MSG_MAP(CAddDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDlg message handlers

BOOL CAddDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int i;

	// 
	for (i=0; i < m_pDlg->m_evtType.GetSize(); i++)
	{
		m_almType.AddString(m_pDlg->m_evtType[i].szDesc);
	}
	m_almType.SetCurSel(0);

	// ȼ
	for (i=0; i < m_pDlg->m_priType.GetSize(); i++)
	{
		m_prio.AddString(m_pDlg->m_priType[i].desc);
	}
	m_prio.SetCurSel(0);

	// Ȩ
	for (i=0; i < m_pDlg->m_aojType.GetSize(); i++)
	{
		m_aoj.AddString(m_pDlg->m_aojType[i].szDesc);
	}
	m_aoj.SetCurSel(0);

	// Ӧϵͳ
	for (i=0; i < m_pDlg->m_appSysType.GetSize(); i++)
	{
		m_appSys.AddString(m_pDlg->m_appSysType[i].szDesc);
	}
	m_appSys.SetCurSel(0);

	// 豸
	for (i=0; i < m_pDlg->m_devType.GetSize(); i++)
	{
		m_devType.AddString(m_pDlg->m_devType[i].szDesc);
	}
	m_devType.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CAddDlg::OnExit()
{
	CDialog::OnCancel();
}
void CAddDlg::OnAdd() 
{
	if (!RBAC_CheckPrivilege(DEF_RIGHT_SEDATA))
	{
		AfxMessageBox("ûдȨ!");
		CDialog::OnCancel();
		return;
	}
	UpdateData();

	CTime tm(m_dateYMD.GetYear(), m_dateYMD.GetMonth(), m_dateYMD.GetDay(),
		m_dateHMS.GetHour(), m_dateHMS.GetMinute(), m_dateHMS.GetSecond());

	CString sql;
	sql.Format("insert into SEDATUM.TB3001_ALMH "
		"values (%d, %d, '%s', '%s', %d, %d, %d, %d, %d, '%s', '%s', '%s', '%s', '%s', '%s',%d,%d)",
		tm.GetTime(),
		m_msec,
		m_dev,
		m_pDlg->m_evtType[m_almType.GetCurSel()].szName,
		m_serial,
		m_pDlg->m_priType[m_prio.GetCurSel()].pri,
        m_pDlg->m_appSysType[m_appSys.GetCurSel()].sAppSys,
		m_pDlg->m_aojType[m_aoj.GetCurSel()].sAoj,
		m_pDlg->m_devType[m_devType.GetCurSel()].sType,
		m_szObjGroup,
		m_szObj1,
		m_szObj2,
		m_szObj3,
		m_szObj4,
		m_szContent,
		0,
		0
		);

	CSE_DBOption dbo;
	if (dbo.ExecuteOneCmd((LPTSTR)(LPCTSTR)sql) == SEDB_SUCCESS)
	{
		MessageBox("¼ӳɹ!", "ӳɹ", MB_ICONINFORMATION | MB_OK);
	    CDialog::OnOK();
	}
	else
	{
		MessageBox("¼ʧ!", "ʧ", MB_ICONERROR | MB_OK);
	    CDialog::OnCancel();
	}
}
