// ChangDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "ChangDlg.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangDlg dialog


CChangDlg::CChangDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangDlg)
	m_szObj1 = _T("");
	m_szObj2 = _T("");
	m_szObj3 = _T("");
	m_szObj4 = _T("");
	m_szObjGroup = _T("");
	m_szContent = _T("");
	//}}AFX_DATA_INIT
	m_pDlg = (CEhhevtView *)pParent;
}


void CChangDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangDlg)
	DDX_Control(pDX, IDC_PRIO, m_prio);
	DDX_Control(pDX, IDC_DEVTYPE, m_devType);
	DDX_Control(pDX, IDC_AOJ, m_aoj);
	DDX_Control(pDX, IDC_APPSYS, m_appSys);
	DDX_Text(pDX, IDC_OBJ1, m_szObj1);
	DDV_MaxChars(pDX, m_szObj1, 12);
	DDX_Text(pDX, IDC_OBJ2, m_szObj2);
	DDV_MaxChars(pDX, m_szObj2, 12);
	DDX_Text(pDX, IDC_OBJ3, m_szObj3);
	DDV_MaxChars(pDX, m_szObj3, 12);
	DDX_Text(pDX, IDC_OBJ4, m_szObj4);
	DDV_MaxChars(pDX, m_szObj4, 12);
	DDX_Text(pDX, IDC_OBJGROUP, m_szObjGroup);
	DDV_MaxChars(pDX, m_szObjGroup, 8);
	DDX_Text(pDX, IDC_CONTENT, m_szContent);
	DDV_MaxChars(pDX, m_szContent, 128);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangDlg, CDialog)
	//{{AFX_MSG_MAP(CChangDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangDlg message handlers

BOOL CChangDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CMainFrame* pFrame =(CMainFrame*)g_pApp->m_pMainWnd;
	int nRow = m_pDlg->m_pGridCtrl->GetFocusCell().row;

	int i;
	CString str;

	str = m_pDlg->m_pGridCtrl->GetItemText(nRow, 6);

	// ȼ
	for (i=0; i < pFrame->GetExView()->m_priType.GetSize(); i++)
	{
		m_prio.AddString(pFrame->GetExView()->m_priType[i].desc);

		if (str == pFrame->GetExView()->m_priType[i].desc)
			m_prio.SetCurSel(i);
	}

	str = m_pDlg->m_pGridCtrl->GetItemText(nRow, 7);

	// Ӧϵͳ
	for (i=0; i < pFrame->GetExView()->m_appSysType.GetSize(); i++)
	{
		m_appSys.AddString(pFrame->GetExView()->m_appSysType[i].szDesc);

		if (str == pFrame->GetExView()->m_appSysType[i].szDesc)
			m_appSys.SetCurSel(i);
	}

	str = m_pDlg->m_pGridCtrl->GetItemText(nRow, 8);

	// Ȩ
	for (i=0; i < pFrame->GetExView()->m_aojType.GetSize(); i++)
	{
		m_aoj.AddString(pFrame->GetExView()->m_aojType[i].szDesc);

		if (str == pFrame->GetExView()->m_aojType[i].szDesc)
			m_aoj.SetCurSel(i);
	}	
	
	str = m_pDlg->m_pGridCtrl->GetItemText(nRow, 9);

	// 豸
	for (i=0; i < pFrame->GetExView()->m_devType.GetSize(); i++)
	{
		m_devType.AddString(pFrame->GetExView()->m_devType[i].szDesc);

		if (str == pFrame->GetExView()->m_devType[i].szDesc)
			m_devType.SetCurSel(i);
	}

	m_szObjGroup = m_pDlg->m_pGridCtrl->GetItemText(nRow, 10);
	m_szObj1	 = m_pDlg->m_pGridCtrl->GetItemText(nRow, 11);
	m_szObj2	 = m_pDlg->m_pGridCtrl->GetItemText(nRow, 12);
	m_szObj3	 = m_pDlg->m_pGridCtrl->GetItemText(nRow, 13);
	m_szObj4	 = m_pDlg->m_pGridCtrl->GetItemText(nRow, 14);
	m_szContent  = m_pDlg->m_pGridCtrl->GetItemText(nRow, 15);
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChangDlg::OnOK() 
{
	CMainFrame* pFrame =(CMainFrame*)g_pApp->m_pMainWnd;
	if(!RBAC_CheckPrivilege(DEF_RIGHT_SEDATA))
	{
		AfxMessageBox("ûдȨ!");
		CDialog::OnCancel();
		return;
	}
    if(m_prio.GetCurSel() <0)
	{
        AfxMessageBox("ȼûѡ!");
		CDialog::OnCancel();
		return;
	}
	if(m_aoj.GetCurSel() <0)
	{
        AfxMessageBox("Ȩûѡ!");
		CDialog::OnCancel();
		return;
	}
	if(m_devType.GetCurSel() <0)
	{
        AfxMessageBox("豸ûѡ!");
		CDialog::OnCancel();
		return;
	}
	if(m_appSys.GetCurSel() <0)
	{
        AfxMessageBox("Ӧϵͳûѡ!");
		CDialog::OnCancel();
		return;
	}
	UpdateData();

	int nRow = m_pDlg->m_pGridCtrl->GetFocusCell().row;

	BYTE serial = (BYTE)m_pDlg->m_pGridCtrl->GetItemData(nRow, 1);
	long second = m_pDlg->m_pGridCtrl->GetItemData(nRow, 2);
	long msec = m_pDlg->m_pGridCtrl->GetItemData(nRow, 3);
	CString devKey = m_pDlg->m_pGridCtrl->GetItemText(nRow, 4);
	short index = (short)m_pDlg->m_pGridCtrl->GetItemData(nRow, 5);

	CString sql;
	sql.Format(
		"update SEDATUM.TB3001_ALMH "
		"set F3001_ALMPRIO = %d, F3001_APPSYSID = %d,F3001_AOJ = %d, F3001_DEVTYPE = %d, "
			"F3001_GROUPNAME = '%s', F3001_USERATTR1 = '%s', F3001_USERATTR2 = '%s', "
			"F3001_USERATTR3 = '%s', F3001_USERATTR4 = '%s', F3001_TEXT = '%s' "
		"where F3001_SERIAL = %d and F3001_DATE = %d "
			"and F3001_MICROSEC = %d and F3001_DEVKEY = '%s'",
		pFrame->GetExView()->m_priType[m_prio.GetCurSel()].pri,
         pFrame->GetExView()->m_appSysType[m_appSys.GetCurSel()].sAppSys,
		pFrame->GetExView()->m_aojType[m_aoj.GetCurSel()].sAoj,
		pFrame->GetExView()->m_devType[m_devType.GetCurSel()].sType,
		m_szObjGroup,
		m_szObj1,
		m_szObj2,
		m_szObj3,
		m_szObj4,
		m_szContent,
		serial,
		second,
		msec,
		devKey);

	// if almclass can't be found, exclude from conditions.
	CString almClass;
	if (index >= 0)
	{
		almClass.Format(" and F3001_ALMCLASS = '%s'", pFrame->GetExView()->m_evtType[index].szName);
		sql += almClass;
	}

	CSE_DBOption dbo;
	if (dbo.ExecuteOneCmd((LPTSTR)(LPCTSTR)sql) != SEDB_SUCCESS)
	{
		AfxMessageBox("ݿʧ!");
		CDialog::OnCancel();
	}

	m_pDlg->m_pGridCtrl->SetItemText(nRow, 6,  pFrame->GetExView()->m_priType[m_prio.GetCurSel()].desc);
//		pFrame->GetExView()->m_priType[m_prio.GetCurSel()].desc);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 7,  pFrame->GetExView()->m_appSysType[m_appSys.GetCurSel()].szDesc);//
	//pFrame->GetExView()->m_aojType[m_aoj.GetCurSel()].szDesc);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 8,  pFrame->GetExView()->m_aojType[m_aoj.GetCurSel()].szDesc);//
	CString s =pFrame->GetExView()->m_aojType[m_aoj.GetCurSel()].szDesc;
	//pFrame->GetExView()->m_devType[m_devType.GetCurSel()].szDesc);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 9,  pFrame->GetExView()->m_devType[m_devType.GetCurSel()].szDesc);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 10,m_szObjGroup);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 11, m_szObj1);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 12, m_szObj2);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 13, m_szObj3);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 14, m_szObj4);
	m_pDlg->m_pGridCtrl->SetItemText(nRow, 15, m_szContent);
	m_pDlg->m_pGridCtrl->Refresh();

	CDialog::OnOK();
}
