// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "Ehhevtdoc.h"
#include "EhhevtView.h"
#include "ToolView.h"
#include "MainFrm.h"
#include "CfgSheet.h"
#include "adddlg.h"
#include "ChangDlg.h"
#include "interface\si_bcg.h"

#include "ReportDlg.h"

//#include "CommonDef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame
/*
//ⷢĽ̵ãSCADAڲ󶨱ʵʱ
	 int AlmSignal(const char* UserName,ALM_D_BASE_INFO AlmInfo );
	 Hisalm
*/
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDI_ICON1, OnPrint)
	ON_UPDATE_COMMAND_UI(IDI_ICON1, OnUpdatePrint)
	ON_COMMAND(IDI_ICON4, OnAdd)
	ON_UPDATE_COMMAND_UI(IDI_ICON4, OnUpdateAdd)
	ON_COMMAND(IDI_ICON5,OnModify)
    ON_UPDATE_COMMAND_UI(IDI_ICON5, OnUpdateModify)
	ON_COMMAND(IDI_ICON3,OnSet)
	ON_UPDATE_COMMAND_UI(IDI_ICON3, OnUpdateSet)
	ON_COMMAND(IDI_ICON6,OnDel)
	ON_UPDATE_COMMAND_UI(IDI_ICON6, OnUpdateDel)
	ON_COMMAND(IDI_ICON7,OnHelp)
	ON_UPDATE_COMMAND_UI(IDI_ICON7, OnUpdateHelp)
	ON_COMMAND(IDI_ICON8,OnFirst)
	ON_UPDATE_COMMAND_UI(IDI_ICON8, OnUpdateFirst)
	//ON_COMMAND(IDI_ICON9,OnPre)
	//ON_UPDATE_COMMAND_UI(IDI_ICON9, OnUpdatePre)
	//ON_COMMAND(IDI_ICON10,OnNext)
	//ON_UPDATE_COMMAND_UI(IDI_ICON10, OnUpdateNext)
	ON_COMMAND(IDI_ICON11,OnLast)
	ON_UPDATE_COMMAND_UI(IDI_ICON11, OnUpdateLast)
	ON_WM_TIMER()
	ON_COMMAND(ID_REPORT, OnReport)
	ON_COMMAND(IDC_BTN_PRE,OnPre)
	//ON_UPDATE_COMMAND_UI(IDC_BTN_PRE, OnUpdatePre)
	ON_COMMAND(IDC_BTN_NEXT,OnNext)
	//ON_UPDATE_COMMAND_UI(IDC_BTN_NEXT, OnUpdateNext)
	ON_COMMAND(IDC_BTN_SKIP,OnSkip)
	//ON_UPDATE_COMMAND_UI(IDC_BTN_SKIP, OnUpdateSkip)
	ON_COMMAND(IDC_BTN_SAVE, OnBtnSave)
	ON_COMMAND(IDC_BTN_SAVE2, OnBtnSave2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,	
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}
CMainFrame::~CMainFrame()
{
}
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!this->CreateExToolBar())
		return -1;
	//m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);

	m_ImageList.Create(IDB_IMAGELIST,13, 1, RGB(0,255,0));
	  
	m_wndWorkspace.SetBtnImageList (&m_ImageList);
	if (!m_wndWorkspace.Create(this, IDR_MENU_BANK,
			_T("ѯ"), CSize(383,100)))
	{
			TRACE0("Failed to create dialog bar m_wndWorkspace\n");
			return -1;		// fail to create
	}
	m_wndWorkspace.AddView(_T(""), RUNTIME_CLASS(CToolView));


	m_wndWorkspace.SetBarStyle(m_wndWorkspace.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
/*
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	UINT nID, nStyle;
	int cxWidth;
	m_wndStatusBar.GetPaneInfo(1, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo(1, nID, SBPS_NORMAL, 150);
	m_wndStatusBar.SetPaneText(1, _T("¼:0"), TRUE);

	m_wndStatusBar.GetPaneInfo(2, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo(2, nID, SBPS_NORMAL, 70);
	m_wndStatusBar.SetPaneText(2, _T("0/0 ҳ"), TRUE);

	m_wndStatusBar.GetPaneInfo(3, nID, nStyle, cxWidth);
	m_wndStatusBar.SetPaneInfo(3, nID, SBPS_NORMAL, 70);
	m_wndStatusBar.SetPaneText(3, _T("    I S C S "), TRUE);//WYF 20190507 Hide
	*/
//	m_wndStatusBar.ShowWindow(SW_HIDE);//WYF 20190507 Hide
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndWorkspace.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndWorkspace, AFX_IDW_DOCKBAR_RIGHT);
	

	if (!m_btmToolBar.Create(this, IDD_DIALOG_BTMBAR, WS_CHILD | CBRS_BOTTOM | CBRS_FLYBY |
		CBRS_SIZE_FIXED, IDD_DIALOG_BTMBAR))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	m_btmToolBar.EnableDocking(CBRS_ALIGN_BOTTOM);
	EnableDocking(CBRS_ALIGN_BOTTOM);
	DockControlBar(&m_btmToolBar, AFX_IDW_DOCKBAR_BOTTOM);

	SetTimer(1, 1000, NULL);
	SetTimer(2, 100, NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	m_strTitle = "ʷ¼ѯ";  		
	cs.style &= ~(LONG)FWS_ADDTOTITLE;
	cs.hMenu = NULL;
	//WYF 20190507
	/*cs.style &= ~(WS_MINIMIZEBOX);    
	cs.style^=WS_MAXIMIZEBOX;*/    
    cs.style&=~WS_THICKFRAME; 
	cs.x=0;cs.y=120;
	cs.cx=1920;
	cs.cy=848;//WYF 20190507
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::CreateExToolBar()
{/*//wyf 20181008 յ1.7Ҫȡ,
    CImageList img;
	CString str;
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	UINT id;
	CString szText;
	for (int i = 0; i < m_wndToolBar.GetCount(); i++)
	{
		id = m_wndToolBar.GetItemID(i);
		if (!szText.LoadString(id))
			continue;
		
		int j = szText.Find('\n');
		if (j == -1)
			continue;
		
		szText = szText.Right(szText.GetLength() - j - 1);
		m_wndToolBar.SetButtonText(i, szText);
		CRect rc;
		m_wndToolBar.GetItemRect(0, rc);
		m_wndToolBar.SetSizes(rc.Size(), CSize(16, 15));
	}*///wyf 20181008 յ1.7Ҫȡ,
/*	if(!m_wndReBar.Create(this))
	{
		return -1;
	}
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC))
	{
		return -1;      
	}
	//ĴðťĿȺͳ
	m_wndToolBar.GetToolBarCtrl().SetButtonWidth(30, 40);
	
	//Ĵ""λͼ
	img.Create(22, 22, ILC_COLOR8|ILC_MASK,2,2);
	img.SetBkColor(::GetSysColor(COLOR_BTNFACE));

	img.Add(AfxGetApp()->LoadIcon(IDI_ICON1));//ӡ
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON2));//ӡԤ
	
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON3));//
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON4));// 
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON5));//޸
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON6));//ɾ
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON7));//
   
	m_wndToolBar.GetToolBarCtrl().SetHotImageList(&img);
	img.Detach();	
	
	//Ĵ""λͼ
	img.Create(19, 19, ILC_COLOR8|ILC_MASK, 2,2);

	img.SetBkColor(::GetSysColor(COLOR_BTNFACE));
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON1));//ӡ
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON2));//ӡԤ

	img.Add(AfxGetApp()->LoadIcon(IDI_ICON3));//
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON4));// 
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON5));//޸
    img.Add(AfxGetApp()->LoadIcon(IDI_ICON6));//ɾ
	img.Add(AfxGetApp()->LoadIcon(IDI_ICON7));//
	m_wndToolBar.GetToolBarCtrl().SetImageList(&img);

	img.Detach();
	
	//ı
	m_wndToolBar.ModifyStyle(0, TBSTYLE_FLAT |CBRS_TOOLTIPS | TBSTYLE_TRANSPARENT|TBBS_CHECKBOX );
	m_wndToolBar.SetButtons(NULL,7);
	
	// set up each toolbar button  
	
	m_wndToolBar.SetButtonInfo(0, IDI_ICON1, TBBS_BUTTON   , 0);
	m_wndToolBar.SetButtonText(0, "ӡ");	
	
	m_wndToolBar.SetButtonInfo(1, IDI_ICON2, TBBS_BUTTON   , 1);
	m_wndToolBar.SetButtonText(1, "Ԥ");
	
	m_wndToolBar.SetButtonInfo(2, IDI_ICON3, TBBS_BUTTON   , 2);
	m_wndToolBar.SetButtonText(2, "");

	m_wndToolBar.SetButtonInfo(3, IDI_ICON4, TBBS_BUTTON   , 3);
	m_wndToolBar.SetButtonText(3, "");

	m_wndToolBar.SetButtonInfo(4, IDI_ICON5, TBBS_BUTTON   , 4);
	m_wndToolBar.SetButtonText(4, "޸");
	
	m_wndToolBar.SetButtonInfo(5, IDI_ICON6, TBBS_BUTTON   , 5);
	m_wndToolBar.SetButtonText(5, "ɾ");

	m_wndToolBar.SetButtonInfo(6, IDI_ICON7, TBBS_BUTTON   , 6);
	m_wndToolBar.SetButtonText(6, "");

	CRect rectToolBar;
	//õťĴС
	m_wndToolBar.GetItemRect(0, &rectToolBar);
	//ðťĴС
	m_wndToolBar.SetSizes(rectToolBar.Size(), CSize(20,20));
	
	//RebarмToolBar
	m_wndReBar.AddBar(&m_wndToolBar);
	
	//ıһЩ
	REBARBANDINFO rbbi;
	rbbi.cbSize = sizeof(rbbi);		//Ǳ
	rbbi.fMask = RBBIM_CHILDSIZE | RBBIM_IDEALSIZE | RBBIM_SIZE|RBBIM_BACKGROUND;
	//Ŀ
	rbbi.cxMinChild = rectToolBar.Width();
	//߶
	rbbi.cyMinChild = rectToolBar.Height();
	//дΪ뱳λͼעrbbi.fMaskRBBIM_BACKGROUND־
	rbbi.hbmBack = LoadBitmap(::AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_TOOLBARBKMAP));
	
	rbbi.cx = rbbi.cxIdeal = rectToolBar.Width() * 10;
	
	m_wndReBar.GetReBarCtrl().SetBandInfo(0, &rbbi);*/
//	m_wndReBar.EnableDocking(CBRS_ALIGN_ANY);
	return TRUE;
}
void CMainFrame::OnPrint()
{
	CEhhevtView* pView =GetView();
	pView->m_pGridCtrl->Print();
}
void CMainFrame::OnUpdatePrint(CCmdUI* pCmdUI) 
{

}

void CMainFrame::OnAdd()
{
	CAddDlg dlg(GetExView());
	if(dlg.DoModal() ==IDOK)
	{
		SendAlarm(0,dlg.m_dev);
	}
}
void CMainFrame::OnUpdateAdd(CCmdUI* pCmdUI) 
{
}
void CMainFrame::OnModify()
{
	int nRow = GetView()->m_pGridCtrl->GetFocusCell().row;
	if(nRow > 0)
	{
		CChangDlg dlg(GetView());
		if(dlg.DoModal() ==IDOK)
		{
            SendAlarm(1,GetView()->m_pGridCtrl->GetItemText(nRow, 4));
		}
	}
}
void CMainFrame::OnUpdateModify(CCmdUI* pCmdUI) 
{
}
void CMainFrame::OnSet()
{
	CEhhevtView* pView=GetView();
	CCfgSheet cfgSheet("ϵͳ", GetExView());
	if(cfgSheet.DoModal() == IDOK)
	{
		pView->SetAllColWidth();

		// Color and count
		pView->m_pGridCtrl->Refresh();
	}
}
void CMainFrame::OnUpdateSet(CCmdUI* pCmdUI) 
{
}
void CMainFrame::OnDel()
{
	CCellID begin(0, 1);

	CCellID end = GetView()->m_pGridCtrl->GetNextItem(begin, GVNI_SELECTED|GVNI_BELOW);
	if(end.row == -1)
	{
		AfxMessageBox("ѡ!");
		return;
	}

	if(MessageBox("ȷɾ?", "ɾ", MB_OKCANCEL | MB_ICONQUESTION) != IDOK)
		return;

	if(!RBAC_CheckPrivilege(DEF_RIGHT_SEDATA))
	{
		AfxMessageBox("ûдȨ!");
		return;
	}

	m_DelList.RemoveAll();
	CString devKey;
	while (end.row != -1)
	{
		BYTE serial = (BYTE)GetView()->m_pGridCtrl->GetItemData(end.row, 1);
		long second = GetView()->m_pGridCtrl->GetItemData(end.row, 2);
		long msec = GetView()->m_pGridCtrl->GetItemData(end.row, 3);
		devKey = GetView()->m_pGridCtrl->GetItemText(end.row, 4);
		short index = (short)GetView()->m_pGridCtrl->GetItemData(end.row, 5);

		CString sql;
		sql.Format(
			"delete from SEDATUM.TB3001_ALMH "
			"where F3001_DATE = %d "
			"and F3001_MICROSEC = %d and F3001_DEVKEY = '%s' and F3001_SERIAL = %d",
			second, msec, devKey, serial);

		// if almclass can't be found, exclude from conditions.
		CString almClass;
		if (index >= 0)
		{
			almClass.Format(" and F3001_ALMCLASS = '%s'", GetExView()->m_evtType[index].szName);
			sql += almClass;
		}

		if(m_dbOption.ExecuteOneCmd((LPTSTR)(LPCTSTR)sql) != SEDB_SUCCESS)
		{
			end = GetView()->m_pGridCtrl->GetNextItem(end, GVNI_SELECTED|GVNI_BELOW);
			continue;
		}

		m_DelList.AddTail(end.row);

		end = GetView()->m_pGridCtrl->GetNextItem(end, GVNI_SELECTED|GVNI_BELOW);
	}

	if(!m_DelList.IsEmpty())
	{
		while(!m_DelList.IsEmpty())
		{
			GetView()->m_pGridCtrl->DeleteRow(m_DelList.RemoveHead());

			POSITION pos = m_DelList.GetHeadPosition();
			if(pos == NULL)
			{
				GetView()->RefreshGrid();
				GetView()->m_pGridCtrl->Refresh();
				SendAlarm(2,devKey);
				return;
			}

			for(int i = 0; i < m_DelList.GetCount(); i++)
			{
				m_DelList.GetNext(pos)--;
			}
		}
	}
	
}
void CMainFrame::OnUpdateDel(CCmdUI* pCmdUI) 
{
}
void CMainFrame::OnHelp()
{
	Clibbcg InfoWnd;
	InfoWnd.About();
}
void CMainFrame::OnUpdateHelp(CCmdUI* pCmdUI) 
{
}	

void CMainFrame::OnFirst()
{
	CToolView* pToolView =(CToolView*)GetExView();
	pToolView->Page(FIRST);
}
void CMainFrame::OnUpdateFirst(CCmdUI* pCmdUI) 
{
	CToolView* pToolView =(CToolView*)GetExView();
	pCmdUI->Enable(pToolView->nPageIdx > 0);
}	

void CMainFrame::OnPre()
{
	CToolView* pToolView =(CToolView*)GetExView();
	if (pToolView->nPageIdx > 0)
	{
		pToolView->Page(PREVIOUS);
	}
}
void CMainFrame::OnUpdatePre(CCmdUI* pCmdUI) 
{
	CToolView* pToolView =(CToolView*)GetExView();
	pCmdUI->Enable(pToolView->nPageIdx > 0);
}

void CMainFrame::OnNext()
{
	CToolView* pToolView =(CToolView*)GetExView();
	if (pToolView->nPageIdx < pToolView->nLastPage && pToolView->IsAlreadyQueryed)
	{
		pToolView->Page(NEXT);
	}
}
void CMainFrame::OnUpdateNext(CCmdUI* pCmdUI) 
{
	CToolView* pToolView =(CToolView*)GetExView();
	pCmdUI->Enable(pToolView->nPageIdx < pToolView->nLastPage && pToolView->IsAlreadyQueryed);
}

void CMainFrame::OnLast()
{
	CToolView* pToolView =(CToolView*)GetExView();
	pToolView->Page(LAST);
}
void CMainFrame::OnUpdateLast(CCmdUI* pCmdUI) 
{
	CToolView* pToolView =(CToolView*)GetExView();
	pCmdUI->Enable(pToolView->nPageIdx < pToolView->nLastPage && pToolView->IsAlreadyQueryed);
}

void CMainFrame::SetcolNum(int val)
{
//    m_wndStatusBar.SetPaneText(1, buf, TRUE);
	m_btmToolBar.SetTotalNum(val);
}

void CMainFrame::SetPageNum(int nCurrPage, int nTotalPage)
{
//	itoa(nTotalPage, szbuf ,10);
 //   m_wndStatusBar.SetPaneText(2, buf, TRUE);	
	if (nCurrPage <= nTotalPage)
	{
		m_btmToolBar.SetPageNum(nCurrPage, nTotalPage);
	}
	else
	{
		m_btmToolBar.SetPageNum(0, 0);
	}
}
CEhhevtView* CMainFrame::GetView()
{
    CView *pView = NULL;
	
	if(g_pDoc)
	{
		POSITION pos = g_pDoc->GetFirstViewPosition();
		while(pos != NULL)
		{
			pView = g_pDoc->GetNextView(pos);
			if(pView->IsKindOf(RUNTIME_CLASS(CEhhevtView)))
				return (CEhhevtView*)pView;
			else 
				pView = NULL;
		}
	}
	return 0;
}

CToolView* CMainFrame::GetExView()
{
	CView *pView = NULL;
	pView =m_wndWorkspace.GetView(0);
	if(pView->IsKindOf(RUNTIME_CLASS(CToolView)))
		return (CToolView*)pView;
	else 
		return NULL;

}

void CMainFrame::SetToolBarShow()
{
    m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON1,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON2,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON3,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON4,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON5,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON6,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON7,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON8,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON9,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON10,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON11,TBSTATE_ENABLED);
	RecalcLayout( );
}

void CMainFrame::SetToolBarHide()
{
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON1,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON2,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON3,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON4,TBSTATE_HIDDEN);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON5,TBSTATE_HIDDEN);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON6,TBSTATE_HIDDEN);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON7,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON8,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON9,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON10,TBSTATE_ENABLED);
	m_wndToolBar.GetToolBarCtrl().SetState(IDI_ICON11,TBSTATE_ENABLED);
	RecalcLayout( );
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent )
	{
	case 1:
		{
	    //if(RBAC_CheckPrivilege(DEF_RIGHT_SEDATA))
		//	   SetToolBarShow();
		 //   else
		//	   SetToolBarHide();
		}
	break;
    case 2:
		{
//++++			SetWindowText("ʷ澯ѯ");
		}
	    break;
	}
	
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::SendAlarm(int Val,CString DevKey)
{
	char szCode[128];
	char szUsername[RBAC_K_USER_DESCRIPTION_LEN];
	char szRole[RBAC_K_ROLE_DESCRIPTION_LEN];
	memset(szUsername,0,sizeof(szUsername));
	memset(szRole,0,sizeof(szRole));
    memset(szCode,0,sizeof(szCode));
	if(RBAC_GetUserRoleDescription(szCode,szUsername,szRole)!=TRUE)
	{
		strcpy(szUsername,_T("û"));
		strcpy(szRole,_T(""));
	}
    UINT unAoj=0;
    //AOJ_GetAssignment(NULL, unAoj);
	CScdCsi	csi_Hevt;
	ALM_D_BASE_INFO alminfo={0};
//	char desctmp[SE_K_DESC];
	memset(&alminfo,0,sizeof(ALM_D_BASE_INFO));
	strcpy(alminfo.DeviceKey,DevKey);//UserCode
    strcpy(alminfo.ClassName,"HisAlm");  
    alminfo.MessageId = Val+1;
	alminfo.Operator=ALM_K_OPR_ALM;
	CSeTime kt;
	TCriterionTime ct;
	kt.GetNow(&ct,&alminfo.Msec);
	alminfo.Second = ct;
	alminfo.Priority=ALM_K_PRI_EVENT;
	alminfo.Aoj=unAoj;
	alminfo.DeviceType=0;
	strcpy(alminfo.GroupName,"");
	
	strcpy(alminfo.Graph,"");
	alminfo.AttrNum=2;
	strcpy(alminfo.UserAttrList[0].UserAttrName,"User");
	strcpy(alminfo.UserAttrList[0].UserAttrVal,szCode);
	strcpy(alminfo.UserAttrList[0].UserAttrValDesc,szUsername);
	
	strcpy(alminfo.UserAttrList[1].UserAttrName,"Console");
	get_host_name(alminfo.UserAttrList[1].UserAttrVal);
	strcpy(alminfo.UserAttrList[1].UserAttrValDesc,alminfo.UserAttrList[1].UserAttrVal);
	
	csi_Hevt.AlmSignal(szUsername,alminfo);

}

void CMainFrame::OnReport() 
{
	CReportDlg dlg(this);
	dlg.DoModal();
}

void CMainFrame::OnSkip()
{
	CToolView* pToolView =(CToolView*)GetExView();
	int skipNum = m_btmToolBar.GetSkipNum();
	if (pToolView->nPageIdx < pToolView->nLastPage && pToolView->IsAlreadyQueryed && skipNum <= pToolView->nLastPage +1 && skipNum > 0)
	{		
		pToolView->Page(SKIP, skipNum);
	}
}
void CMainFrame::OnUpdateSkip(CCmdUI* pCmdUI) 
{
	CToolView* pToolView =(CToolView*)GetExView();
	int skipNum = m_btmToolBar.GetSkipNum();
	pCmdUI->Enable(skipNum <= pToolView->nLastPage +1 && skipNum > 0  && pToolView->IsAlreadyQueryed);
}

//2
BOOL CMainFrame::WriteToExcel(CEhhevtView* pView, CString &csStrFile)
{
	BOOL bRet = FALSE;
	if (pView == NULL)
	{
		return bRet;
	}
	
	CDatabase database;
	CString strDriver = "MICROSOFT EXCEL DRIVER (*.xls)"; //excelװ
	CString strSql;

	int len = csStrFile.GetLength();
	int num = csStrFile.ReverseFind('\\');
	CString dir = csStrFile.Left(num + 1);
	CString dimap = dir + "ʷ¼ѯ.xls";
	
	TRY 
	{
		//дȡַ
		strSql.Format("DRIVER={%s};DSN='';FIRSTROWHASNAMES=1;READONLY=FALSE;\
			CREATE_DB=\"%s\";DBQ=%s", strDriver, csStrFile, csStrFile);
		//ݿ---excelļ
		if (database.OpenEx(strSql, CDatabase::noOdbcDialog))
		{
			//ṹ
			int i = 0;
			CString csItemText, csHeadTemp, csInsertTemp;
			CString csHeadField = _T(""), csInsertField = _T("");
			int nCurCol = 0, nColValid = 0;
			for (i = pView->m_nCols; i >= 0; i--)
			{
				if (pView->m_pGridCtrl->GetColumnWidth(i) > 0)
				{
					nCurCol = i;	//ȡһк
					break;
				}
			}
			nColValid = nCurCol;csItemText = _T(" ");
			for (int headCol = 0; headCol < nColValid; headCol++)
			{
				if (pView->m_pGridCtrl->GetColumnWidth(headCol) > 0)
				{
					csItemText = headCol ==0 ? _T("") : pView->m_pGridCtrl->GetItemText(0, headCol);
					if (csItemText.IsEmpty())
					{
						csItemText.Format(_T("%d"), headCol+1);
					}
					csHeadTemp.Format(_T("%s TEXT,"), csItemText);
					csInsertTemp.Format(_T("%s,"), csItemText);
					csHeadField += csHeadTemp;
					csInsertField += csInsertTemp;
				}
				csItemText = _T("");
			}
			csItemText = pView->m_pGridCtrl->GetItemText(0, nCurCol);
			if (csItemText.IsEmpty())
			{
				csItemText.Format(_T("%d"), nCurCol+1);
			}
			csHeadTemp.Format(_T("%s TEXT"), csItemText);
			csInsertTemp.Format(_T("%s"), csItemText);
			csHeadField += csHeadTemp;
			csInsertField += csInsertTemp;
			strSql.Format("CREATE TABLE [ʷ¼ѯ] (%s)", csHeadField);
			database.ExecuteSQL(strSql);
			//ֵ
			CString csInsertVal = _T("");
			csItemText = _T("");
			for (i = 1; i <= pView->m_nRows; i++)
			{
				for (int nCol = 0; nCol < nColValid; nCol++)
				{
					if (pView->m_pGridCtrl->GetColumnWidth(nCol) > 0)
					{
						csItemText = pView->m_pGridCtrl->GetItemText(i, nCol);
						csInsertTemp.Format(_T("\'%s\',"), csItemText);
						csInsertVal += csInsertTemp;
						csItemText = _T("");
					}		
				}
				csItemText = pView->m_pGridCtrl->GetItemText(i, nCurCol);
				csInsertTemp.Format(_T("\'%s\'"), csItemText);
				csInsertVal += csInsertTemp;	
				strSql.Format("INSERT INTO [ʷ¼ѯ] (%s) VALUES (%s)", csInsertField, csInsertVal);
				database.ExecuteSQL(strSql);
				csInsertVal = _T("");
				csItemText = _T("");
			}
			bRet = TRUE;
		}
		//رݿ---excel
		database.Close();
	}
	CATCH (CMemoryException, e)
	{
		//ݿ쳣ʱ
		printf("ݿexcel\n");
	}

	END_CATCH
	return bRet;
}

void CMainFrame::OnBtnSave()
{
	CEhhevtView* pView = GetView();
	if (pView->m_nCols <= 1)
	{
		return;
	}
	char cFilter[256] = {0};
	CString csStrFile;
	strcpy(cFilter, "Excelļ (*.xls)|*.xls||");
	CFileDialog Dlg(FALSE, "xls", "*.xls", OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, cFilter, NULL);
	if (Dlg.DoModal() == IDOK)
	{
		csStrFile = Dlg.GetPathName();
		WriteToExcel(pView, csStrFile);
	}
}

void CMainFrame::OnBtnSave2()
{
	CEhhevtView* pView = GetView();
	if (pView->m_nCols <= 1)
	{
		return;
	}
	char cFilter[256] = { 0 };
	CString csStrFile;
	strcpy(cFilter, "Excelļ (*.xls)|*.xls||");
	CFileDialog Dlg(FALSE, "xls", "*.xls", OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, cFilter, NULL);
	if (Dlg.DoModal() == IDOK)
	{
		csStrFile = Dlg.GetPathName();
		CString tail = ".xls";
		int position = csStrFile.Find(tail);
		int page = 0;

		CToolView* pToolView = (CToolView*)GetExView();
		
		pToolView->Page(SKIP, 1);
		
		page = pToolView->nLastPage;

		for (int i = 0; i < (page+1); i++)
		{
			CString str;
			str.Format("%d", i + 1);
			CString s = "_" + str;
			CString savepath = csStrFile;
			savepath.Insert(position, s);
			WriteToExcel(pView, savepath);
			OnNext();
		}
		
	}
}