// ToolView.cpp : implementation file
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "mainfrm.h"
#include "Ehhevtdoc.h"

#include "Ehhevtview.h"

#include "ToolView.h"
#include "sqlstmt.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToolView

IMPLEMENT_DYNCREATE(CToolView, CFormView)

CToolView::CToolView()
	: CFormView(CToolView::IDD)
{
	//{{AFX_DATA_INIT(CToolView)
	m_startTime = 0;
	m_endTime = 0;
	m_endHour = 0;
	m_startHour = 0;
	m_nSRadio =-1;
	CTime t = CTime::GetCurrentTime();
	m_startTime = CTime(t.GetYear(), t.GetMonth(), 1, 0, 0, 0);
	m_endTime = t;
	m_startHour = t;
	m_endHour = t;
	m_chkGroup = FALSE;
	m_chkSys = FALSE;
	m_chkDevType = FALSE;
	m_chkPrior = FALSE;
	m_chkEvtType = FALSE;
	m_chkTime = FALSE;
	//}}AFX_DATA_INIT
	nPageIdx = 0;
}

CToolView::~CToolView()
{
}

void CToolView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolView)
    DDX_Control(pDX, IDC_COMBODEV, m_ctrlDev);
	DDX_Control(pDX, IDC_COMBOAOJ, m_ctrlAoj);
	DDX_Control(pDX, IDC_COMBOAPPSYS, m_ctrlAppSys);
	DDX_Control(pDX, IDC_BUTTON_TYPE, m_ctrlType);
	DDX_Control(pDX, IDC_BUTTON_SORT, m_ctrlPrio);
	DDX_Control(pDX, IDC_COMBOUSR, m_ctrlUser);
	DDX_Control(pDX, IDC_STATIC_USER, m_UserImg);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER1, m_startTime);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER2, m_endTime);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER4, m_endHour);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER3, m_startHour);
	DDX_Radio(pDX, IDC_RADIO_STA, m_nSRadio);
	DDX_Control(pDX, IDC_COMBOGROUP, m_ctrlGroup);//wyf 20181008
	DDX_Check(pDX, IDC_CHECK_GROUP, m_chkGroup);
	DDX_Check(pDX, IDC_CHECK_SYS, m_chkSys);
	DDX_Check(pDX, IDC_CHECK_DEVTYPE, m_chkDevType);
	DDX_Check(pDX, IDC_CHECK_PRIOR, m_chkPrior);
	DDX_Check(pDX, IDC_CHECK_EVTTYPE, m_chkEvtType);
	DDX_Check(pDX, IDC_CHECK_TIME, m_chkTime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CToolView, CFormView)
	//{{AFX_MSG_MAP(CToolView)
	ON_WM_CTLCOLOR()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RADIO_STA, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_STATION, OnStation)
	ON_BN_CLICKED(IDC_QUERY, OnQuery)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(IDI_ICON2/*ID_FILE_PRINT_PREVIEW*/, CView::OnFilePrintPreview)
	ON_BN_CLICKED(IDC_BTNPRINT, OnBtnPrint)//wyf 20181008
	ON_BN_CLICKED(IDC_CHECK_GROUP, OnChkGroup)
	ON_BN_CLICKED(IDC_CHECK_SYS, OnChkSys)
	ON_BN_CLICKED(IDC_CHECK_DEVTYPE, OnChkDevType)
	ON_BN_CLICKED(IDC_CHECK_PRIOR, OnChkPrior)
	ON_BN_CLICKED(IDC_CHECK_EVTTYPE, OnChkEvtType)
	ON_BN_CLICKED(IDC_CHECK_TIME, OnChkTime)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolView diagnostics

#ifdef _DEBUG
void CToolView::AssertValid() const
{
	CFormView::AssertValid();
}

void CToolView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CToolView message handlers
HBRUSH CToolView::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{	
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
    if(nCtlColor==CTLCOLOR_LISTBOX )
	{
		pDC->SetTextColor(RGB(255,255,255));//WYF 20180718 RGB(0,0,0)
		pDC->SetBkColor(RGB(7,54,80));//WYF 20180718 RGB(255,255,0)
		//HBRUSH b=CreateSolidBrush(RGB(7,54,80));//WYF 20180718 RGB(255,255,0)
		//return b;
		return m_brush1;
	}
	else if(nCtlColor==CTLCOLOR_EDIT)
	{
		pDC->SetTextColor(RGB(0,0,0));
		pDC->SetBkColor(RGB(255,255,255));
		//HBRUSH b=CreateSolidBrush(RGB(255,255,255));
		//return b;
		return m_brush2;
	}
	else if(nCtlColor==CTLCOLOR_DLG )
	{
    	pDC->SetTextColor(RGB(0,0,0));
	    pDC->SetBkColor(RGB(7,54,80));//WYF 20180718 RGB(115,123,140)
	    //HBRUSH b=CreateSolidBrush(RGB(7,54,80));//WYF 20180718 RGB(115,123,140)
	    //return b;
		return m_brush1;
	}
	else if(nCtlColor==CTLCOLOR_STATIC)
	{
		pDC->SetTextColor(RGB(255,255,255));//WYF 20180718 RGB(0,0,0)
	    pDC->SetBkColor(RGB(7,54,80));//WYF 20180718 RGB(115,123,140)
	    //HBRUSH b=CreateSolidBrush(RGB(7,54,80));//WYF 20180718 RGB(115,123,140)
	    //return b;
		return m_brush1;
	}
    return hbr;	

	
}

void CToolView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
		//ôڴС
}

void CToolView::OnInitialUpdate() 
{
	IsAlreadyQueryed = FALSE;
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	m_UserImg.SetImage(IDB_BITMAP_USER);

	if (!InitAllData())
	{
		MessageBox("ݿѯʧܣ˳", "ѯʧ", MB_ICONERROR | MB_OK);
		return ;
	}
	CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
    InitCombo();
    
	m_lCount = GetPrivateProfileInt("History", "MaxCount", 5000, pApp->m_szCfgPath);
	m_lLimitCount = GetPrivateProfileInt("History", "LimitCount", 10000, pApp->m_szCfgPath);
	m_sortOrder = GetPrivateProfileInt("History", "ʱ", 0, pApp->m_szCfgPath);
	if (m_lCount > 5000)
	{
		m_lCount = 5000;
	}
	
	m_bStation = false;
	m_nSRadio =TRUE;
	GetDlgItem(IDC_STATION)->EnableWindow(!m_nSRadio);
	GetDlgItem(IDC_COMBOUSR)->EnableWindow(m_nSRadio);
	((CButton*)GetDlgItem(IDC_RADIO_STA))->SetCheck(m_nSRadio);
	((CButton*)GetDlgItem(IDC_RADIO2))->SetCheck(!m_nSRadio);
	memset(&m_con, 0, sizeof(CON));

	m_brush1.CreateSolidBrush(RGB(7,54,80));
	m_brush2.CreateSolidBrush(RGB(255,255,255));
}

BOOL CToolView::InitAllData()
{
    CSE_DBOption dbo;
    CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
	// -------------------------Init Group------------------------wyf 20181008
	if (dbo.BeginSelectRcdSet(SQL_GROUP) != SEDB_SUCCESS)
		return FALSE;
    int i=0;
	int retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_group.SetSize(retcount);
		
		for ( i = 0; i < retcount; i++)
		{
			strcpy(m_group[i].szName, dbo.GetStringVal(i, 1));//GroupCode
			strcpy(m_group[i].szDesc, dbo.GetStringVal(i, 2));//GroupDesc
		}
	}
	dbo.EndSelectRcdSet();

	// -------------------------Init Priority------------------------
	if (dbo.BeginSelectRcdSet(SQL_ALMPRI) != SEDB_SUCCESS)
		return FALSE;
	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_priType.SetSize(retcount);

		for ( i = 0; i < retcount; i++)
		{
			m_priType[i].pri = dbo.GetByteVal(i, 0);
			strcpy(m_priType[i].desc, dbo.GetStringVal(i, 1));
			m_priType[i].color = dbo.GetUIntVal(i, 2);
		}
	}
	dbo.EndSelectRcdSet();

	// --------------------------Init EType--------------------------
	if (dbo.BeginSelectRcdSet(SQL_ALMCLASS) != SEDB_SUCCESS)
		return FALSE;

	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_evtType.SetSize(retcount);

		m_TypeMap.InitHashTable((UINT)(retcount*1.2));

		for (i = 0; i < retcount; i++)
		{
			strcpy(m_evtType[i].szName, dbo.GetStringVal(i, 0));
			strcpy(m_evtType[i].szDesc, dbo.GetStringVal(i, 1));

			m_TypeMap[m_evtType[i].szName] = i;
		}
	}
	dbo.EndSelectRcdSet();

	// --------------------------Init user---------------------------
	if (dbo.BeginSelectRcdSet(SQL_USER) != SEDB_SUCCESS)
		return FALSE;

	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_userStr.SetSize(retcount);
		m_userDesStr.SetSize(retcount);
		for (i = 0; i < retcount; i++)
		{
			m_userStr[i] = dbo.GetStringVal(i, 1);

			m_userDesStr[i] = dbo.GetStringVal(i, 0);
		}
	}
	dbo.EndSelectRcdSet();

	// --------------------Init DevType------------------------------
	if (dbo.BeginSelectRcdSet(SQL_DEVTYPE) != SEDB_SUCCESS)
		return FALSE;

	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_devType.SetSize(retcount);

		m_devMap.InitHashTable((UINT)(retcount*1.2));

		for (i = 0; i < retcount; i++)
		{
			m_devType[i].sType = dbo.GetByteVal(i, 0);
			strcpy(m_devType[i].szDesc, dbo.GetStringVal(i, 1));

			m_devMap[m_devType[i].sType] = i;
		}
	}
	dbo.EndSelectRcdSet();

	// ---------------------Init Aoj---------------------------------
	if (dbo.BeginSelectRcdSet(SQL_AOJ) != SEDB_SUCCESS)
		return FALSE;

	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_aojType.SetSize(retcount);

		m_aojMap.InitHashTable((UINT)(retcount*1.2));

		for (i = 0; i < retcount; i++)
		{
			m_aojType[i].sAoj = dbo.GetByteVal(i, 0);
			strcpy(m_aojType[i].szDesc, dbo.GetStringVal(i, 1));

			m_aojMap[m_aojType[i].sAoj] = i;
		}
	}
	dbo.EndSelectRcdSet();

	// ---------------------Init APPSYS---------------------------------
	if (dbo.BeginSelectRcdSet(SQL_APPSYS) != SEDB_SUCCESS)
		return FALSE;

	retcount = dbo.GetRcdCount();
	if(retcount >0)
	{
		m_appSysType.SetSize(retcount);

		m_appSysMap.InitHashTable((UINT)(retcount*1.2));

		for (i = 0; i < retcount; i++)
		{
			m_appSysType[i].sAppSys = dbo.GetByteVal(i, 0);
			strcpy(m_appSysType[i].szDesc, dbo.GetStringVal(i, 1));

			m_appSysMap[m_appSysType[i].sAppSys] = i;
		}
	}
	dbo.EndSelectRcdSet();

	// ---------------------Init Field-------------------------------
// 	if (dbo.BeginSelectRcdSet(SQL_ALMH_FLD) != SEDB_SUCCESS)
// 		return FALSE;
// 
// 	CReadConf cfg;
// 	COLTYPE ct;
// 	char szWidth[MAX_PATH];
// 	char width[10];
// 	short datalen;
// 
// 	m_nCols = dbo.GetRcdCount();
//     if(m_nCols >0)
// 	{
// 		m_colType.SetSize(m_nCols);
// 		for (i = 0; i < m_nCols; i++)
// 		{
// 			strcpy(ct.szName, dbo.GetStringVal(i, 0));
// 			datalen = dbo.GetShortVal(i, 1);
// 
// 			sprintf(szWidth, "%s", ct.szName);
// 			sprintf(width, "%d", datalen > 0 ? min(datalen, 64) * 8 : 64);
// 			ct.lWidth = cfg.ReadLong("History", szWidth, pApp->m_szCfgPath, width);
// 			ct.bSet = cfg.ReadLong("History", ct.szName, pApp->m_szCfgPath, "1") != 0;
// 			m_colType[i] = ct;
// 		}
// 	}
// 	dbo.EndSelectRcdSet();

	return TRUE;
}

void CToolView::InitCombo()
{
    int i;
    CImageList imgList;
	imgList.Create(IDB_TREE_ICONS, 18, 1, RGB(0xFF, 0xFF, 0xFF));
	//---------------------Init Group---------------------------------wyf 20181008
	m_ctrlGroup.AddString("");
	for (i = 0; i < m_group.GetSize(); i++)
	{
		m_ctrlGroup.AddString(m_group[i].szDesc);
	}
    m_ctrlGroup.SetCurSel(0);
	
	// -------------------------Init Priority------------------------
    m_ctrlPrio.InsertCaption(1);

	for (i = 0; i < m_priType.GetSize(); i++)
	{
	    m_ctrlPrio.AddString(m_priType[i].desc,i,ROOT_LEVEL + 1);
	}
	m_ctrlPrio.CheckAll(TRUE);
    m_ctrlPrio.SetImageList( &imgList );
	
	// --------------------------Init EType--------------------------
    m_ctrlType.InsertCaption(2);

	for (i = 0; i < m_evtType.GetSize(); i++)
	{
		m_ctrlType.AddString(m_evtType[i].szDesc,i,ROOT_LEVEL + 1);
	}
    m_ctrlType.CheckAll(TRUE);
    m_ctrlType.SetImageList( &imgList );

	// --------------------------Init user---------------------------
	m_ctrlUser.ResetContent();
	m_ctrlUser.AddString("");
	for (i = 0; i < m_userStr.GetSize(); i++)
	{
		m_ctrlUser.AddString(m_userStr[i]);
	}
	m_ctrlUser.SetCurSel(0);

	// --------------------Init DevType------------------------------
	m_ctrlDev.AddString(TEXT(""));
	for (i = 0; i < m_devType.GetSize(); i++)
	{
		m_ctrlDev.AddString(m_devType[i].szDesc);
	}
	m_ctrlDev.SetCurSel(0);

	//---------------------Init Aoj---------------------------------
	m_ctrlAoj.AddString("");
	for (i = 0; i < m_aojType.GetSize(); i++)
	{
		m_ctrlAoj.AddString(m_aojType[i].szDesc);
	}
	m_ctrlAoj.SetCurSel(0);

	//---------------------Init App---------------------------------
	m_ctrlAppSys.AddString("");
	for (i = 0; i < m_appSysType.GetSize(); i++)
	{
		m_ctrlAppSys.AddString(m_appSysType[i].szDesc);
	}
    m_ctrlAppSys.SetCurSel(0);	
}

void CToolView::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_STATION)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBOUSR)->EnableWindow(TRUE);
    m_nSRadio =TRUE;
}

void CToolView::OnRadio2() 
{
	// TODO: Add your control notification handler code here
    GetDlgItem(IDC_COMBOUSR)->EnableWindow(FALSE);
	GetDlgItem(IDC_STATION)->EnableWindow(TRUE);
	m_nSRadio =FALSE;
}

void CToolView::OnStation() 
{
	// TODO: Add your control notification handler code here
	CON con;
	if (((CEhhevtApp *)AfxGetApp())->m_Sel.GetConValue(con))
	{
		if(con.sDevType == 0)
		{
			m_bStation = false;
			GetDlgItem(IDC_STATION)->SetWindowText(con.szDesc);
			return;
		}
		m_con = con;
		m_bStation = true;
		GetDlgItem(IDC_STATION)->SetWindowText(con.szDesc);
	}
}

char* CToolView::GetSqlText(bool bCount, int nPageIdx)
{
    memset(m_szSql,0,sizeof(m_szSql));
    CString strSQL =_T("");
	CTime stm(m_startTime.GetYear(), m_startTime.GetMonth(), m_startTime.GetDay(),
		m_startHour.GetHour(), m_startHour.GetMinute(), m_startHour.GetSecond());//wyf 20181102 add min sec

	CTime etm(m_endTime.GetYear(), m_endTime.GetMonth(), m_endTime.GetDay(),
		m_endHour.GetHour(), m_endHour.GetMinute(), m_endHour.GetSecond());//wyf 20181102 add min sec

	// ʱ
	CString strTime;
	if (m_chkTime)
	{
		if (stm > etm)
		{
			memset(m_szSql,0,sizeof(m_szSql));
			return m_szSql;
		}
		else
		{
			strTime.Format("F3001_DATE between %d and %d", stm.GetTime(), etm.GetTime());
		}
	}
	
	// 
	char m_szType[1536];
	memset(m_szType,0,sizeof(m_szType));
	CString strType=_T("");
	CString str =m_ctrlType.GetCheckedTexts();
	if ( str.Find("")<0 && m_chkEvtType)
	{
		CString s;
		for (int i = 0; i < m_ctrlType.GetCount(); i++)
		{
			if (m_ctrlType.GetCheck(i))
			{
				s = m_evtType[i].szName;
				if (strlen(m_szType)==0)
				{
					strType = "(F3001_ALMCLASS = '" + s + "'";
					strcpy(m_szType,strType);
				}
				else
				{
					strType = " or F3001_ALMCLASS = '" + s + "'";
					strcat(m_szType,strType);
				}
			}
		}

		if (strlen(m_szType)!=0)
		{
			strType = ")";
			strcat(m_szType,strType);
		}
	}

	// ȼ
	CString strPrio;
	str =m_ctrlPrio.GetCheckedTexts();
	if (str.Find("")<0 && m_chkPrior)
	{
		CString s;
		for (int i = 0; i < m_ctrlPrio.GetCount(); i++)
		{
			if (m_ctrlPrio.GetCheck(i))
			{
				s.Format("%d", m_priType[i].pri);
				if (strPrio.IsEmpty())
				{
					strPrio = "(F3001_ALMPRIO = " + s;
				}
				else
				{
					strPrio += " or F3001_ALMPRIO = " + s;
				}
			}
		}

		if (!strPrio.IsEmpty())
		{
			strPrio += ")";
		}
	}

	// Ȩ
	CString strAoj;
	if (m_ctrlAoj.GetCurSel())
	{
		strAoj.Format("F3001_AOJ=%d",m_aojType[m_ctrlAoj.GetCurSel() - 1].sAoj);
	}

	// Ӧϵͳ
	CString strAppSys;
	if (m_ctrlAppSys.GetCurSel() && m_chkSys)
	{
		strAppSys.Format("F3001_APPSYSID = %d", m_appSysType[m_ctrlAppSys.GetCurSel() - 1].sAppSys);
	}

	// 豸
	CString strDev;
	if (m_ctrlDev.GetCurSel() && m_chkDevType)
	{
		strDev.Format("F3001_DEVTYPE = %d", m_devType[m_ctrlDev.GetCurSel() - 1].sType);
	}

	// û
	CString strGroup,strUser;
/*	if (m_nSRadio == 1)
	{
		// վ
		if(m_bStation)
			strGroup.Format("F3001_GROUPNAME = '%s'", m_con.szCode);
	}
	else
	{
		// û
		int i=m_ctrlUser.GetCurSel();
		if (i>0)
			strGroup.Format("F3001_USERATTR1 = '%s'", m_userDesStr[m_ctrlUser.GetCurSel()-1]);
	}
*/
	//wyf 20181102 
	if (m_ctrlGroup.GetCurSel() && m_chkGroup)
	{
		strGroup.Format("F3001_GROUPNAME = '%s'", m_group[m_ctrlGroup.GetCurSel() - 1].szName);
	}//wyf 20181102
	if(0<m_ctrlUser.GetCurSel()){
		strUser.Format("F3001_USERATTR1 = '%s'", m_userDesStr[m_ctrlUser.GetCurSel()-1]);
		if(0==strGroup.GetLength())
			strGroup=strGroup + strUser;
		else
			strGroup=strGroup + " AND " + strUser;
	}
/*	if(bCount)
	{
		strSQL.Format("select %s from SEDATUM.TB3001_ALMH t where %s",
			bCount ? "count(*)" : "*", strTime);
	}
	else
	{
		strSQL.Format("select * from(select A.*, rownum RN from(select %s from SEDATUM.TB3001_ALMH t where %s",
			bCount ? "count(*)" : "*", strTime);
	}*/
	if(bCount)
	{
		strSQL.Format("select %s from SEDATUM.TB3001_ALMH t",
			bCount ? "count(*)" : "*");
	}
	else
	{
		strSQL.Format("select * from(select A.*, rownum RN from(select %s from SEDATUM.TB3001_ALMH t",
			bCount ? "count(*)" : "*");
	}
	int hasWhere = 0;	//sqlwhere־
    sprintf(m_szSql,strSQL);
	if (m_chkTime)
	{
		strcat(m_szSql, " where ");
		strcat(m_szSql, strTime);
		hasWhere = 1;
	}
	if (strlen(m_szType) !=0)
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, m_szType);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, m_szType);
			hasWhere = 1;
		}
	}

	if (!strPrio.IsEmpty())
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, strPrio);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, strPrio);
			hasWhere = 1;
		}
	}

	if (!strAoj.IsEmpty())
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, strAoj);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, strAoj);
			hasWhere = 1;
		}
	}
	
	if (!strAppSys.IsEmpty())
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, strAppSys);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, strAppSys);
			hasWhere = 1;
		}
	}

	if (!strDev.IsEmpty())
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, strDev);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, strDev);
			hasWhere = 1;
		}
	}

	if (!strGroup.IsEmpty())
	{
		if (hasWhere)
		{
			strcat(m_szSql, " and ");
			strcat(m_szSql, strGroup);
		}
		else
		{
			strcat(m_szSql, " where ");
			strcat(m_szSql, strGroup);
			hasWhere = 1;
		}
	}
	CString strLimt;
	strLimt.Format("rownum <= %d", m_lLimitCount);
	if (hasWhere)
	{
		strcat(m_szSql, " and ");
		strcat(m_szSql, strLimt);
	}
	else
	{
		strcat(m_szSql, " where ");
		strcat(m_szSql, strLimt);
		hasWhere = 1;
	}
	if (nPageIdx == 0)
	{
		memset(m_filterSql, 0, sizeof(m_filterSql));
		strcpy(m_filterSql, m_szSql);
	}
	if(!bCount)
	{
		strcpy(m_szSql, m_filterSql);
		strLimt.Format(" order by F3001_Date %s, F3001_Microsec %s ", m_sortOrder ? "asc" : "desc", m_sortOrder ? "asc" : "desc");
		strcat(m_szSql, strLimt);
		char szbuf[20];
		memset(szbuf, 0, sizeof(szbuf));
		int Max_RN = (nPageIdx + 1) * m_lCount;
		itoa(Max_RN, szbuf, 10);
		strcat(m_szSql, ") A where rownum <= ");
		strcat(m_szSql, szbuf);
		strcat(m_szSql, ") where RN > ");
		int	Min_RN = nPageIdx * m_lCount;
		itoa(Min_RN, szbuf, 10);
		strcat(m_szSql, szbuf);
	}
	return m_szSql;
}

void CToolView::OnQuery() 
{
	// TODO: Add your control notification handler code here
	nPageIdx = 0;
	nLastPage = 1;
	GetDlgItem(IDC_QUERY)->EnableWindow(FALSE);
	BeginWaitCursor();
	UpdateData();
	//ѯ¼
	GetSqlText(true);
	if(strlen(m_szSql) == 0)
	{
		AfxMessageBox("ȷѡѯʱ!");
		EndWaitCursor();
	    GetDlgItem(IDC_QUERY)->EnableWindow(TRUE);
		return;
	}
	if(m_dbOption.BeginSelectRcdSet(m_szSql) != SEDB_SUCCESS)
	{
		GetDlgItem(IDC_QUERY)->EnableWindow(TRUE);
		EndWaitCursor();
		return;
	}
	lCount = *(long*)m_dbOption.GetColVal(0, 0);
	if(lCount % m_lCount)
	{
		nLastPage = lCount/m_lCount;
	}
	else
	{
		nLastPage = lCount/m_lCount - 1;
	}
	m_dbOption.EndSelectRcdSet();
	//ѯ¼
	GetSqlText();
	if(strlen(m_szSql) == 0)
	{
		AfxMessageBox("ȷѡѯʱ!");
		EndWaitCursor();
	    GetDlgItem(IDC_QUERY)->EnableWindow(TRUE);
		return;
	}
	if(m_dbOption.BeginSelectRcdSet(m_szSql) != SEDB_SUCCESS)
	{
		ResetGridContext();
		EndWaitCursor();
	    GetDlgItem(IDC_QUERY)->EnableWindow(TRUE);
		return;
	}
	m_nRows = m_dbOption.GetRcdCount();

	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	pMain->SetcolNum(lCount);
	pMain->SetPageNum(nPageIdx + 1, nLastPage + 1);
    pView->m_pGridCtrl->LockWindowUpdate();
    pView->m_pGridCtrl->DeleteAllItems();
	pView->m_nRows =m_nRows;
	m_nCols = pView->m_nCols;
    pView->InitGridHead();
	for (int row = 0; row < m_nRows; row++)
	{
		int index = GetPriorityNo(m_dbOption.GetByteVal(row, 5));
		GV_ITEM Item;
		Item.mask = GVIF_TEXT;
		Item.row = row+1;
		Item.col = 0;
		CString strText;
		strText.Format("%d", row+1);
		Item.strText = strText;
		pView->m_pGridCtrl->SetItem(&Item);
		for (int col = 0; col < m_nCols; col++)
		{
			GV_ITEM Item;
			Item.mask = GVIF_TEXT;
			Item.row = row+1;
			Item.col = col+1;
			long lData;
			Item.strText = GetGridText(row, col, lData);
			// primary key, save number data to lParam
			if (col == 1 || col == 2 || col == 3 || col == 5)
			{
				Item.mask |= GVIF_PARAM;
				Item.lParam = (LPARAM)lData;
			}
			if (col >= 0 && index >= 0)
			{
				Item.mask |= GVIF_BKCLR;
				Item.mask |= GVIF_FGCLR;//WYF 20180719
//				Item.crBkClr = m_priType[index].color;
				Item.crFgClr = m_priType[index].color;//WYF 20180719
				Item.crBkClr = RGB(7,54,80);//WYF 20180719
			}
			else if (index < 0)
			{
				Item.mask |= GVIF_BKCLR;
				Item.mask |= GVIF_FGCLR;
				Item.crFgClr = RGB(255, 255, 255);
				Item.crBkClr = RGB(7, 54, 80);
			}
			pView->m_pGridCtrl->SetItem(&Item);
		}
	}
	m_dbOption.EndSelectRcdSet();
	pView->m_pGridCtrl->UnlockWindowUpdate();
//    pView->m_pGridCtrl->AutoSize();//WYF 20180719
	EndWaitCursor();
	GetDlgItem(IDC_QUERY)->EnableWindow(TRUE);
	IsAlreadyQueryed=TRUE;
}

void CToolView::Page(int nFlags, int nSkip)
{
	BeginWaitCursor();
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	const int PAGE[] = { 0, nPageIdx - 1, nPageIdx + 1, nLastPage, nSkip - 1};
	GetSqlText(false, PAGE[nFlags]);
	nPageIdx = PAGE[nFlags];
	if(m_dbOption.BeginSelectRcdSet(m_szSql) != SEDB_SUCCESS)
	{
		EndWaitCursor();
		return;
	}

	int m_nRows = m_dbOption.GetRcdCount();
//	pMain->SetcolNum(m_nRows);
	pMain->SetPageNum(nPageIdx + 1, nLastPage + 1);
    pView->m_pGridCtrl->LockWindowUpdate();
	pView->m_pGridCtrl->DeleteAllItems();
	pView->m_nRows = m_nRows;
	//pView->m_nCols = m_nCols;
	pView->InitGridHead();
	for (int row = 0; row < m_nRows; row++)
	{
		int index = GetPriorityNo(m_dbOption.GetByteVal(row, 5));
		GV_ITEM Item;
		Item.mask = GVIF_TEXT;
		Item.row = row+1;
		Item.col = 0;
		CString strText;
		strText.Format("%d", row+1);
		Item.strText = strText;
		pView->m_pGridCtrl->SetItem(&Item);
		for (int col = 0; col < m_nCols; col++)
		{
			GV_ITEM Item;
			Item.mask = GVIF_TEXT;
			Item.row = row+1;
			Item.col = col+1;
			long lData;
			Item.strText = GetGridText(row, col, lData);
			// primary key, save number data to lParam
			if (col == 1 || col == 2 || col == 3 || col == 5)
			{
				Item.mask |= GVIF_PARAM;
				Item.lParam = (LPARAM)lData;
			}

			if (col >= 0 && index >= 0)
			{
				Item.mask |= GVIF_BKCLR;
				Item.mask |= GVIF_FGCLR;//WYF 20180719
//				Item.crBkClr = m_priType[index].color;
				Item.crFgClr = m_priType[index].color;//WYF 20180719
				Item.crBkClr = RGB(7,54,80);//WYF 20180719
			}
			else if (index < 0)
			{
				Item.mask |= GVIF_BKCLR;
				Item.mask |= GVIF_FGCLR;
				Item.crFgClr = RGB(255, 255, 255);
				Item.crBkClr = RGB(7, 54, 80);
			}
			pView->m_pGridCtrl->SetItem(&Item);
		}
	}
	m_dbOption.EndSelectRcdSet();
	pView->m_pGridCtrl->UnlockWindowUpdate();
//    pView->m_pGridCtrl->AutoSize();//WYF 20180719
	EndWaitCursor();
}

void CToolView::ResetGridContext()
{}

int CToolView::GetPriorityNo(int pri)
{
    for (int i = 0; i < m_priType.GetSize(); i++)
	{
		if (m_priType[i].pri == pri)
			return i;
	}
	return -1;
}
//lDataʹɾ޸Ĺѷ---add by sjw 2020.1.14
CString CToolView::GetGridText(int row, int col, long &lData)
{
    CSeTime SE_T;
	static SSE_CLOCK clock;

	CString strText;
	CMainFrame* pFrmae = (CMainFrame*)g_pApp->m_pMainWnd;
			
	char buf[64];
	memset(buf,0,sizeof(buf));
	strcpy(buf,pFrmae->GetView()->m_colType[col].szName);

	if(strcmp(buf ,"к")==0)
		{
			BYTE serial = m_dbOption.GetByteVal(row, 4);
			lData = serial;
			strText.Format("%d", serial);
		}
	
	
	else if(strcmp(buf ,"ʱ")==0)
		{
			TCriterionTime second = m_dbOption.GetIntVal(row, _T("F3001_DATE"));
			short ms = m_dbOption.GetShortVal(row, _T("F3001_MICROSEC"));
			lData = second;
			SE_T.CovertTime(second, &clock);
			strText.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d", clock.year, clock.month, clock.day, clock.hour, clock.minute, clock.second,ms);
		}


else if(strcmp(buf ,"")==0)
		{
			short ms = m_dbOption.GetShortVal(row, _T("F3001_MICROSEC"));
			lData = ms;
			strText.Format("%03d", ms);
		}


else if(strcmp(buf ,"豸")==0)
	{
		strText = m_dbOption.GetStringVal(row, _T("F3001_DEVKEY"));
	}

else if(strcmp(buf ,"")==0)
		{
			char *pszType = m_dbOption.GetStringVal(row, _T("F3001_ALMCLASS"));
			short sIndex = -1;
			if(pszType != NULL)
			{
				if (m_TypeMap.Lookup(pszType, sIndex))
				strText = m_evtType[sIndex].szDesc;
			}
			else
			{
				strText = _T("");
			}
			lData = sIndex;
		}
		else if(strcmp(buf ,"ȼ")==0)
		{
			BYTE prio = m_dbOption.GetByteVal(row, _T("F3001_ALMPRIO"));
			int index = GetPriorityNo(prio);
			if (index >= 0)
				strText = m_priType[index].desc;
			else
				strText.Format("%d", prio);
		}
	
else if(strcmp(buf ,"ϵͳ")==0)
		{
			short appsysid = m_dbOption.GetShortVal(row, _T("F3001_APPSYSID"));
			short sIndex;
			if (m_appSysMap.Lookup(appsysid, sIndex))
				strText = m_appSysType[sIndex].szDesc;
		}
	
else if(strcmp(buf ,"Ȩ")==0)
		{
			unsigned int aoj = m_dbOption.GetIntVal(row, _T("F3001_AOJ"));
			short sIndex;
			if (m_aojMap.Lookup(aoj, sIndex))
				strText = m_aojType[sIndex].szDesc;
	
		}
	
else if(strcmp(buf ,"豸")==0)
		{
			short devType = m_dbOption.GetShortVal(row, _T("F3001_DEVTYPE"));
			short sIndex;
			if (m_devMap.Lookup(devType, sIndex))
				strText = m_devType[sIndex].szDesc;
		}

else if(strcmp(buf ,"")==0)
		{
			char szSQL[100];
			sprintf(szSQL, "select F1001_GROUPDESC from SEMODEL.TB1001_GROUP "
				"where F1001_GROUPCODE = '%s'", m_dbOption.GetStringVal(row, 9));
			CSE_DBOption dbo;
			if (dbo.BeginSelectRcdSet(szSQL) != SEDB_SUCCESS)
				return _T("");
			int nRetcount = m_dbOption.GetRcdCount(); 
			if(nRetcount <= 0)
				strText = _T("");
			strText = dbo.GetStringVal(0, _T("F1001_GROUPDESC"));
			dbo.EndSelectRcdSet();
		}

else if(strcmp(buf ,"û1")==0)
		{
			strText = m_dbOption.GetStringVal(row, _T("F3001_USERATTR1"));
		}

else if(strcmp(buf ,"û2")==0)
		{
			strText = m_dbOption.GetStringVal(row, _T("F3001_USERATTR2"));
		}

else if(strcmp(buf ,"û3")==0)
		{
			strText = m_dbOption.GetStringVal(row, _T("F3001_USERATTR3"));
		}

else if(strcmp(buf ,"û4")==0)
		{
			strText = m_dbOption.GetStringVal(row, _T("F3001_USERATTR4"));
		}	
else if(strcmp(buf ,"Ϣ")==0)
		{
			strText = m_dbOption.GetStringVal(row, _T("F3001_TEXT"));
		}
else if (strcmp(buf, "Ƿȷ") == 0)
{
	short stateMode = m_dbOption.GetShortVal(row, _T("F3001_STATE"));
	if (stateMode & ((int)BeConfirm))
	{
		strText = _T("ȷ");
	}
	else
	{
		strText = _T("δȷ");
	}
}
else if (strcmp(buf, "Ƿָ") == 0)
{
	short stateMode = m_dbOption.GetShortVal(row, _T("F3001_STATE"));
	if (stateMode & ((int)BeResume))
	{
		strText = _T("ѻָ");
	}
	else
	{
		strText = _T("δָ");
	}
}
else if (strcmp(buf, "ָʱ") == 0)
{
	short stateMode = m_dbOption.GetShortVal(row, _T("F3001_STATE"));
	short ms = m_dbOption.GetShortVal(row, _T("F3001_RSTMS"));
	TCriterionTime secondNum = m_dbOption.GetIntVal(row, _T("F3001_RSTTIME"));
	if ((stateMode & ((int)BeResume)) && ms >= 0 && secondNum > 0)
	{
		SE_T.CovertTime(secondNum, &clock);
		strText.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d", clock.year, clock.month, clock.day, clock.hour, clock.minute, clock.second, ms);
	}
	else
	{
		strText = _T("");
	}
}
else if (strcmp(buf, "ȷʱ") == 0)
{
	short stateMode = m_dbOption.GetShortVal(row, _T("F3001_STATE"));
	short ms = m_dbOption.GetShortVal(row, _T("F3001_ACKMS"));
	TCriterionTime secondNum = m_dbOption.GetIntVal(row, _T("F3001_ACKTIME"));
	if ((stateMode & ((int)BeConfirm)) && ms >= 0 && secondNum > 0)
	{
		SE_T.CovertTime(secondNum, &clock);
		strText.Format("%04d-%02d-%02d %02d:%02d:%02d.%03d", clock.year, clock.month, clock.day, clock.hour, clock.minute, clock.second, ms);
	}
	else
	{
		strText = _T("");
	}
}
else if (strcmp(buf, "ȷʱ") == 0)
{
	short ms = m_dbOption.GetShortVal(row, _T("F3001_ACKMS"));
	if (ms >= 0)
	{
		strText.Format("%03d", ms);
	}
	else
	{
		strText = _T("");
	}
}
else if (strcmp(buf, "ָʱ") == 0)
{
	short ms = m_dbOption.GetShortVal(row, _T("F3001_RSTMS"));
	if (ms >= 0)
	{
		strText.Format("%03d", ms);
	}
	else
	{
		strText = _T("");
	}
}
else if (strcmp(buf, "ȷ") == 0)
{
	short stateMode = m_dbOption.GetShortVal(row, _T("F3001_STATE"));
	if (stateMode & ((int)BeConfirm))
	{
		strText = m_dbOption.GetStringVal(row, _T("F3001_ACKER"));
	}
	else
		strText = _T("");
}
else
{
	strText = _T("");
}

	
	return strText;
}


void CToolView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	if(pView !=NULL)
	{
	   if (pView->m_pGridCtrl)
		   pView->m_pGridCtrl->OnBeginPrinting(pDC, pInfo);
	}

}

void CToolView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	if(pView !=NULL)
	{
	   if (pView->m_pGridCtrl)
	       pView->m_pGridCtrl->OnEndPrinting(pDC, pInfo);
	}
}

BOOL CToolView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	// TODO: call DoPreparePrinting to invoke the Print dialog box
	return DoPreparePrinting(pInfo);

}
void CToolView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	if(pView !=NULL)
	{
	    if (pView->m_pGridCtrl)
		   pView->m_pGridCtrl->OnPrint(pDC, pInfo);
	}
}

void CToolView::OnBtnPrint() 
{
	CMainFrame* pMain = (CMainFrame*)AfxGetMainWnd();
    CEhhevtView* pView =pMain->GetView();
	if(pView !=NULL)
	{
	pView->m_pGridCtrl->Print();
	}
}

void CToolView::OnChkGroup()
{
	UpdateData();
	GetDlgItem(IDC_COMBOGROUP)->EnableWindow(m_chkGroup);
}
void CToolView::OnChkSys()
{
	UpdateData();
	GetDlgItem(IDC_COMBOAPPSYS)->EnableWindow(m_chkSys);
}
void CToolView::OnChkDevType()
{
	UpdateData();
	GetDlgItem(IDC_COMBODEV)->EnableWindow(m_chkDevType);
}
void CToolView::OnChkPrior()
{
	UpdateData();
	GetDlgItem(IDC_BUTTON_SORT)->EnableWindow(m_chkPrior);
}
void CToolView::OnChkEvtType()
{
	UpdateData();
	GetDlgItem(IDC_BUTTON_TYPE)->EnableWindow(m_chkEvtType);
}
void CToolView::OnChkTime()
{
	UpdateData();
	GetDlgItem(IDC_DATETIMEPICKER1)->EnableWindow(m_chkTime);
	GetDlgItem(IDC_DATETIMEPICKER3)->EnableWindow(m_chkTime);
	GetDlgItem(IDC_DATETIMEPICKER2)->EnableWindow(m_chkTime);
	GetDlgItem(IDC_DATETIMEPICKER4)->EnableWindow(m_chkTime);
}


