#if !defined(AFX_TOOLVIEW_H__51C75F00_4904_4456_B18B_34CA4504BEAD__INCLUDED_)
#define AFX_TOOLVIEW_H__51C75F00_4904_4456_B18B_34CA4504BEAD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ToolView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CToolView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "ImgWnd.h"
#include "Public.h"
#include "CheckComboBox.h"

//λ ȷ 2ѻָ 4
#define BeConfirm 0x2
#define BeResume 0x4

#define SQL_ArrayLength 4096

class CToolView : public CFormView
{
public:
	BOOL IsAlreadyQueryed;
	CToolView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CToolView)
protected:
    char m_szSql[SQL_ArrayLength];	//sql
	char m_filterSql[SQL_ArrayLength];	//ֻȥҳsql䣬ҳʱʹ

// Form Data
public:
	//{{AFX_DATA(CToolView)
	enum { IDD = IDD_FORMVIEW };
	CComboBox	m_ctrlDev;
	CComboBox	m_ctrlAppSys;
	CComboBox	m_ctrlAoj;
	CCheckComboBox	m_ctrlType;
	CCheckComboBox	m_ctrlPrio;
	CComboBox	m_ctrlUser;
	CImgWnd	m_UserImg;
	BOOL m_bStation;
	CON m_con;
	CTime	m_startTime;
	CTime	m_endTime;
	CTime	m_endHour;
	CTime	m_startHour;
	int		m_nSRadio;

	CSE_DBOption m_dbOption;
    long m_lCount;
	long m_lLimitCount;	// ݼ
	CComboBox	m_ctrlGroup;//wyf 20181008
	//}}AFX_DATA

// Attributes
public:
	long lCount, nLastPage;
	int m_nCols, m_nRows, nPageIdx;
	CStringArray m_userStr;
    CStringArray m_userDesStr;
	CArray<ETYPE, ETYPE&> m_group;//wyf 20181008
 
	CArray<ALMPRI, ALMPRI&> m_priType;
	CArray<ETYPE, ETYPE&> m_evtType;
    CArray<ATYPE, ATYPE&> m_aojType;
    CArray<APPTYPE, APPTYPE&> m_appSysType;
	CArray<DTYPE, DTYPE&> m_devType;
    CArray<COLTYPE, COLTYPE&> m_colType;

	CMap<CString, const char*, short, short> m_TypeMap;
	CMap<short, short, short, short> m_aojMap;
	CMap<short, short, short, short> m_devMap;
	CMap<short, short, short, short> m_appSysMap;
// Operations
public:
	void Page(int nFlags, int nSkip=0);
	CString GetGridText(int row, int col, long& lData);
	int GetPriorityNo(int pri);
	char* GetSqlText(bool bCount = false, int nPageIdx = 0);
	void InitCombo();
	BOOL InitAllData();
	

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CToolView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CToolView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CToolView)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnPaint();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	afx_msg void OnStation();
	//afx_msg void OnQuery();
	afx_msg void OnGroup();//wyf 20181008
	afx_msg void OnBtnPrint();//wyf 20181008
	afx_msg void OnChkGroup();
	afx_msg void OnChkSys();
	afx_msg void OnChkDevType();
	afx_msg void OnChkPrior();
	afx_msg void OnChkEvtType();
	afx_msg void OnChkTime();
	//}}AFX_MSG
public:
	//{{AFX_MSG(CToolView)
	afx_msg void OnQuery();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
//private:
	void ResetGridContext();
private:
	BOOL m_chkGroup;
	BOOL m_chkSys;
	BOOL m_chkDevType;
	BOOL m_chkPrior;
	BOOL m_chkEvtType;
	BOOL m_chkTime;
	CBrush m_brush1;
	CBrush m_brush2;
	int m_sortOrder;	//ʽ 1:asc 0:desc
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TOOLVIEW_H__51C75F00_4904_4456_B18B_34CA4504BEAD__INCLUDED_)
